]> git.ipfire.org Git - thirdparty/u-boot.git/blob - Makefile
Makefile: Make flash.bin target available for all platforms
[thirdparty/u-boot.git] / Makefile
1 # SPDX-License-Identifier: GPL-2.0+
2
3 VERSION = 2022
4 PATCHLEVEL = 10
5 SUBLEVEL =
6 EXTRAVERSION =
7 NAME =
8
9 # *DOCUMENTATION*
10 # To see a list of typical targets execute "make help"
11 # More info can be located in ./README
12 # Comments in this file are targeted only to the developer, do not
13 # expect to learn how to build the kernel reading this file.
14
15 # Do not use make's built-in rules and variables
16 # (this increases performance and avoids hard-to-debug behaviour)
17 MAKEFLAGS += -rR
18
19 # Determine target architecture for the sandbox
20 include include/host_arch.h
21 ifeq ("", "$(CROSS_COMPILE)")
22 MK_ARCH="${shell uname -m}"
23 else
24 MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^[[:space:]]*\([^\/]*\/\)*\([^-]*\)-[^[:space:]]*/\2/p'}"
25 endif
26 unexport HOST_ARCH
27 ifeq ("x86_64", $(MK_ARCH))
28 export HOST_ARCH=$(HOST_ARCH_X86_64)
29 else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
30 export HOST_ARCH=$(HOST_ARCH_X86)
31 else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
32 export HOST_ARCH=$(HOST_ARCH_AARCH64)
33 else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7a" "armv7l"))
34 export HOST_ARCH=$(HOST_ARCH_ARM)
35 else ifeq ("riscv32", $(MK_ARCH))
36 export HOST_ARCH=$(HOST_ARCH_RISCV32)
37 else ifeq ("riscv64", $(MK_ARCH))
38 export HOST_ARCH=$(HOST_ARCH_RISCV64)
39 endif
40 undefine MK_ARCH
41
42 # Avoid funny character set dependencies
43 unexport LC_ALL
44 LC_COLLATE=C
45 LC_NUMERIC=C
46 export LC_COLLATE LC_NUMERIC
47
48 # Avoid interference with shell env settings
49 unexport GREP_OPTIONS
50
51 # We are using a recursive build, so we need to do a little thinking
52 # to get the ordering right.
53 #
54 # Most importantly: sub-Makefiles should only ever modify files in
55 # their own directory. If in some directory we have a dependency on
56 # a file in another dir (which doesn't happen often, but it's often
57 # unavoidable when linking the built-in.o targets which finally
58 # turn into vmlinux), we will call a sub make in that other dir, and
59 # after that we are sure that everything which is in that other dir
60 # is now up to date.
61 #
62 # The only cases where we need to modify files which have global
63 # effects are thus separated out and done before the recursive
64 # descending is started. They are now explicitly listed as the
65 # prepare rule.
66
67 # Beautify output
68 # ---------------------------------------------------------------------------
69 #
70 # Normally, we echo the whole command before executing it. By making
71 # that echo $($(quiet)$(cmd)), we now have the possibility to set
72 # $(quiet) to choose other forms of output instead, e.g.
73 #
74 # quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
75 # cmd_cc_o_c = $(CC) $(c_flags) -c -o $@ $<
76 #
77 # If $(quiet) is empty, the whole command will be printed.
78 # If it is set to "quiet_", only the short version will be printed.
79 # If it is set to "silent_", nothing will be printed at all, since
80 # the variable $(silent_cmd_cc_o_c) doesn't exist.
81 #
82 # A simple variant is to prefix commands with $(Q) - that's useful
83 # for commands that shall be hidden in non-verbose mode.
84 #
85 # $(Q)ln $@ :<
86 #
87 # If KBUILD_VERBOSE equals 0 then the above command will be hidden.
88 # If KBUILD_VERBOSE equals 1 then the above command is displayed.
89 #
90 # To put more focus on warnings, be less verbose as default
91 # Use 'make V=1' to see the full commands
92
93 ifeq ("$(origin V)", "command line")
94 KBUILD_VERBOSE = $(V)
95 endif
96 ifndef KBUILD_VERBOSE
97 KBUILD_VERBOSE = 0
98 endif
99
100 ifeq ($(KBUILD_VERBOSE),1)
101 quiet =
102 Q =
103 else
104 quiet=quiet_
105 Q = @
106 endif
107
108 # If the user is running make -s (silent mode), suppress echoing of
109 # commands
110
111 ifneq ($(filter 4.%,$(MAKE_VERSION)),) # make-4
112 ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
113 quiet=silent_
114 endif
115 else # make-3.8x
116 ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
117 quiet=silent_
118 endif
119 endif
120
121 export quiet Q KBUILD_VERBOSE
122
123 # kbuild supports saving output files in a separate directory.
124 # To locate output files in a separate directory two syntaxes are supported.
125 # In both cases the working directory must be the root of the kernel src.
126 # 1) O=
127 # Use "make O=dir/to/store/output/files/"
128 #
129 # 2) Set KBUILD_OUTPUT
130 # Set the environment variable KBUILD_OUTPUT to point to the directory
131 # where the output files shall be placed.
132 # export KBUILD_OUTPUT=dir/to/store/output/files/
133 # make
134 #
135 # The O= assignment takes precedence over the KBUILD_OUTPUT environment
136 # variable.
137
138 # KBUILD_SRC is set on invocation of make in OBJ directory
139 # KBUILD_SRC is not intended to be used by the regular user (for now)
140 ifeq ($(KBUILD_SRC),)
141
142 # OK, Make called in directory where kernel src resides
143 # Do we want to locate output files in a separate directory?
144 ifeq ("$(origin O)", "command line")
145 KBUILD_OUTPUT := $(O)
146 endif
147
148 # That's our default target when none is given on the command line
149 PHONY := _all
150 _all:
151
152 # Cancel implicit rules on top Makefile
153 $(CURDIR)/Makefile Makefile: ;
154
155 ifneq ($(KBUILD_OUTPUT),)
156 # Invoke a second make in the output directory, passing relevant variables
157 # check that the output directory actually exists
158 saved-output := $(KBUILD_OUTPUT)
159 KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
160 && /bin/pwd)
161 $(if $(KBUILD_OUTPUT),, \
162 $(error failed to create output directory "$(saved-output)"))
163
164 # Look for make include files relative to root of kernel src
165 #
166 # This does not become effective immediately because MAKEFLAGS is re-parsed
167 # once after the Makefile is read. It is OK since we are going to invoke
168 # 'sub-make' below.
169 MAKEFLAGS += --include-dir=$(CURDIR)
170
171 PHONY += $(MAKECMDGOALS) sub-make
172
173 $(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
174 @:
175
176 sub-make: FORCE
177 $(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
178 -f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
179
180 # Leave processing to above invocation of make
181 skip-makefile := 1
182 endif # ifneq ($(KBUILD_OUTPUT),)
183 endif # ifeq ($(KBUILD_SRC),)
184
185 # We process the rest of the Makefile if this is the final invocation of make
186 ifeq ($(skip-makefile),)
187
188 # Do not print "Entering directory ...",
189 # but we want to display it when entering to the output directory
190 # so that IDEs/editors are able to understand relative filenames.
191 MAKEFLAGS += --no-print-directory
192
193 # Call a source code checker (by default, "sparse") as part of the
194 # C compilation.
195 #
196 # Use 'make C=1' to enable checking of only re-compiled files.
197 # Use 'make C=2' to enable checking of *all* source files, regardless
198 # of whether they are re-compiled or not.
199 #
200 # See the file "doc/sparse.txt" for more details, including
201 # where to get the "sparse" utility.
202
203 ifeq ("$(origin C)", "command line")
204 KBUILD_CHECKSRC = $(C)
205 endif
206 ifndef KBUILD_CHECKSRC
207 KBUILD_CHECKSRC = 0
208 endif
209
210 # Use make M=dir to specify directory of external module to build
211 # Old syntax make ... SUBDIRS=$PWD is still supported
212 # Setting the environment variable KBUILD_EXTMOD take precedence
213 ifdef SUBDIRS
214 KBUILD_EXTMOD ?= $(SUBDIRS)
215 endif
216
217 ifeq ("$(origin M)", "command line")
218 KBUILD_EXTMOD := $(M)
219 endif
220
221 # If building an external module we do not care about the all: rule
222 # but instead _all depend on modules
223 PHONY += all
224 ifeq ($(KBUILD_EXTMOD),)
225 _all: all
226 else
227 _all: modules
228 endif
229
230 ifeq ($(KBUILD_SRC),)
231 # building in the source tree
232 srctree := .
233 else
234 ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
235 # building in a subdirectory of the source tree
236 srctree := ..
237 else
238 srctree := $(KBUILD_SRC)
239 endif
240 endif
241 objtree := .
242 src := $(srctree)
243 obj := $(objtree)
244
245 VPATH := $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
246
247 export srctree objtree VPATH
248
249 # Make sure CDPATH settings don't interfere
250 unexport CDPATH
251
252 #########################################################################
253
254 HOSTARCH := $(shell uname -m | \
255 sed -e s/i.86/x86/ \
256 -e s/sun4u/sparc64/ \
257 -e s/arm.*/arm/ \
258 -e s/sa110/arm/ \
259 -e s/ppc64/powerpc/ \
260 -e s/ppc/powerpc/ \
261 -e s/macppc/powerpc/\
262 -e s/sh.*/sh/)
263
264 HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
265 sed -e 's/\(cygwin\).*/cygwin/')
266
267 export HOSTARCH HOSTOS
268
269 #########################################################################
270
271 # set default to nothing for native builds
272 ifeq ($(HOSTARCH),$(ARCH))
273 CROSS_COMPILE ?=
274 endif
275
276 KCONFIG_CONFIG ?= .config
277 export KCONFIG_CONFIG
278
279 # SHELL used by kbuild
280 CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
281 else if [ -x /bin/bash ]; then echo /bin/bash; \
282 else echo sh; fi ; fi)
283
284 HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
285 HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
286 HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
287
288 HOSTCC = cc
289 HOSTCXX = c++
290 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
291 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
292 KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
293 KBUILD_HOSTLDFLAGS := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
294 KBUILD_HOSTLDLIBS := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
295
296 # With the move to GCC 6, we have implicitly upgraded our language
297 # standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
298 # Some Linux distributions (including RHEL7, SLES13, Debian 8) still
299 # have older compilers as their default, so we make it explicit for
300 # these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
301 CSTD_FLAG := -std=gnu11
302 KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
303
304 ifeq ($(HOSTOS),cygwin)
305 KBUILD_HOSTCFLAGS += -ansi
306 endif
307
308 # Mac OS X / Darwin's C preprocessor is Apple specific. It
309 # generates numerous errors and warnings. We want to bypass it
310 # and use GNU C's cpp. To do this we pass the -traditional-cpp
311 # option to the compiler. Note that the -traditional-cpp flag
312 # DOES NOT have the same semantics as GNU C's flag, all it does
313 # is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
314 #
315 # Apple's linker is similar, thanks to the new 2 stage linking
316 # multiple symbol definitions are treated as errors, hence the
317 # -multiply_defined suppress option to turn off this error.
318 #
319 ifeq ($(HOSTOS),darwin)
320 # get major and minor product version (e.g. '10' and '6' for Snow Leopard)
321 DARWIN_MAJOR_VERSION = $(shell sw_vers -productVersion | cut -f 1 -d '.')
322 DARWIN_MINOR_VERSION = $(shell sw_vers -productVersion | cut -f 2 -d '.')
323
324 os_x_before = $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
325 $(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
326
327 os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
328 $(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
329
330 # Snow Leopards build environment has no longer restrictions as described above
331 HOSTCC = $(call os_x_before, 10, 5, "cc", "gcc")
332 KBUILD_HOSTCFLAGS += $(call os_x_before, 10, 4, "-traditional-cpp")
333 KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
334
335 # macOS Mojave (10.14.X)
336 # Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
337 KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
338 endif
339
340 # Decide whether to build built-in, modular, or both.
341 # Normally, just do built-in.
342
343 KBUILD_MODULES :=
344 KBUILD_BUILTIN := 1
345
346 # If we have only "make modules", don't compile built-in objects.
347 # When we're building modules with modversions, we need to consider
348 # the built-in objects during the descend as well, in order to
349 # make sure the checksums are up to date before we record them.
350
351 ifeq ($(MAKECMDGOALS),modules)
352 KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
353 endif
354
355 # If we have "make <whatever> modules", compile modules
356 # in addition to whatever we do anyway.
357 # Just "make" or "make all" shall build modules as well
358
359 # U-Boot does not need modules
360 #ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
361 # KBUILD_MODULES := 1
362 #endif
363
364 #ifeq ($(MAKECMDGOALS),)
365 # KBUILD_MODULES := 1
366 #endif
367
368 # Check ths size of a binary:
369 # Args:
370 # $1: File to check
371 # #2: Size limit in bytes (decimal or 0xhex)
372 define size_check
373 actual=$$( wc -c $1 | awk '{print $$1}'); \
374 limit=$$( printf "%d" $2 ); \
375 if test $$actual -gt $$limit; then \
376 echo "$1 exceeds file size limit:" >&2; \
377 echo " limit: $$(printf %#x $$limit) bytes" >&2; \
378 echo " actual: $$(printf %#x $$actual) bytes" >&2; \
379 echo " excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
380 exit 1; \
381 fi
382 endef
383 export size_check
384
385 export KBUILD_MODULES KBUILD_BUILTIN
386 export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
387
388 # We need some generic definitions (do not try to remake the file).
389 scripts/Kbuild.include: ;
390 include scripts/Kbuild.include
391
392 # Make variables (CC, etc...)
393
394 AS = $(CROSS_COMPILE)as
395 # Always use GNU ld
396 ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
397 LD = $(CROSS_COMPILE)ld.bfd
398 else
399 LD = $(CROSS_COMPILE)ld
400 endif
401 CC = $(CROSS_COMPILE)gcc
402 CPP = $(CC) -E
403 AR = $(CROSS_COMPILE)ar
404 NM = $(CROSS_COMPILE)nm
405 LDR = $(CROSS_COMPILE)ldr
406 STRIP = $(CROSS_COMPILE)strip
407 OBJCOPY = $(CROSS_COMPILE)objcopy
408 OBJDUMP = $(CROSS_COMPILE)objdump
409 LEX = flex
410 YACC = bison
411 AWK = awk
412 PERL = perl
413 PYTHON ?= python
414 PYTHON2 = python2
415 PYTHON3 ?= python3
416
417 # The devicetree compiler and pylibfdt are automatically built unless DTC is
418 # provided. If DTC is provided, it is assumed the pylibfdt is available too.
419 DTC_INTREE := $(objtree)/scripts/dtc/dtc
420 DTC ?= $(DTC_INTREE)
421 DTC_MIN_VERSION := 010406
422
423 CHECK = sparse
424
425 CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
426 -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
427
428 KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
429
430 KBUILD_CFLAGS := -Wall -Wstrict-prototypes \
431 -Wno-format-security \
432 -fno-builtin -ffreestanding $(CSTD_FLAG)
433 KBUILD_CFLAGS += -fshort-wchar -fno-strict-aliasing
434 KBUILD_AFLAGS := -D__ASSEMBLY__
435 KBUILD_LDFLAGS :=
436
437 ifeq ($(cc-name),clang)
438 ifneq ($(CROSS_COMPILE),)
439 CLANG_TARGET := --target=$(notdir $(CROSS_COMPILE:%-=%))
440 GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
441 CLANG_PREFIX := --prefix=$(GCC_TOOLCHAIN_DIR)
442 GCC_TOOLCHAIN := $(realpath $(GCC_TOOLCHAIN_DIR)/..)
443 endif
444 ifneq ($(GCC_TOOLCHAIN),)
445 CLANG_GCC_TC := --gcc-toolchain=$(GCC_TOOLCHAIN)
446 endif
447 KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
448 KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
449 KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
450 KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
451 endif
452
453 # Don't generate position independent code
454 KBUILD_CFLAGS += $(call cc-option,-fno-PIE)
455 KBUILD_AFLAGS += $(call cc-option,-fno-PIE)
456
457 # Read UBOOTRELEASE from include/config/uboot.release (if it exists)
458 UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
459 UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
460
461 export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
462 export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
463 export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
464 export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
465 export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
466 export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
467
468 export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
469 export KBUILD_CFLAGS KBUILD_AFLAGS
470
471 export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
472
473 # When compiling out-of-tree modules, put MODVERDIR in the module
474 # tree rather than in the kernel tree. The kernel tree might
475 # even be read-only.
476 export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
477
478 # Files to ignore in find ... statements
479
480 export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o \
481 -name CVS -o -name .pc -o -name .hg -o -name .git \) \
482 -prune -o
483 export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
484 --exclude CVS --exclude .pc --exclude .hg --exclude .git
485
486 # ===========================================================================
487 # Rules shared between *config targets and build targets
488
489 # Basic helpers built in scripts/
490 PHONY += scripts_basic
491 scripts_basic:
492 $(Q)$(MAKE) $(build)=scripts/basic
493 $(Q)rm -f .tmp_quiet_recordmcount
494
495 # To avoid any implicit rule to kick in, define an empty command.
496 scripts/basic/%: scripts_basic ;
497
498 PHONY += outputmakefile
499 # outputmakefile generates a Makefile in the output directory, if using a
500 # separate output directory. This allows convenient use of make in the
501 # output directory.
502 outputmakefile:
503 ifneq ($(KBUILD_SRC),)
504 $(Q)ln -fsn $(srctree) source
505 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile $(srctree)
506 endif
507
508 # To make sure we do not include .config for any of the *config targets
509 # catch them early, and hand them over to scripts/kconfig/Makefile
510 # It is allowed to specify more targets when calling make, including
511 # mixing *config targets and build targets.
512 # For example 'make oldconfig all'.
513 # Detect when mixed targets is specified, and make a second invocation
514 # of make so .config is not included in this case either (for *config).
515
516 version_h := include/generated/version_autogenerated.h
517 timestamp_h := include/generated/timestamp_autogenerated.h
518 defaultenv_h := include/generated/defaultenv_autogenerated.h
519 dt_h := include/generated/dt.h
520 env_h := include/generated/environment.h
521
522 no-dot-config-targets := clean clobber mrproper distclean \
523 help %docs check% coccicheck \
524 ubootversion backup tests check pcheck qcheck tcheck \
525 pylint pylint_err
526
527 config-targets := 0
528 mixed-targets := 0
529 dot-config := 1
530
531 ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
532 ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
533 dot-config := 0
534 endif
535 endif
536
537 ifeq ($(KBUILD_EXTMOD),)
538 ifneq ($(filter config %config,$(MAKECMDGOALS)),)
539 config-targets := 1
540 ifneq ($(words $(MAKECMDGOALS)),1)
541 mixed-targets := 1
542 endif
543 endif
544 endif
545
546 ifeq ($(mixed-targets),1)
547 # ===========================================================================
548 # We're called with mixed targets (*config and build targets).
549 # Handle them one by one.
550
551 PHONY += $(MAKECMDGOALS) __build_one_by_one
552
553 $(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
554 @:
555
556 __build_one_by_one:
557 $(Q)set -e; \
558 for i in $(MAKECMDGOALS); do \
559 $(MAKE) -f $(srctree)/Makefile $$i; \
560 done
561
562 else
563 ifeq ($(config-targets),1)
564 # ===========================================================================
565 # *config targets only - make sure prerequisites are updated, and descend
566 # in scripts/kconfig to make the *config target
567
568 KBUILD_DEFCONFIG := sandbox_defconfig
569 export KBUILD_DEFCONFIG KBUILD_KCONFIG
570
571 config: scripts_basic outputmakefile FORCE
572 $(Q)$(MAKE) $(build)=scripts/kconfig $@
573
574 %config: scripts_basic outputmakefile FORCE
575 $(Q)$(MAKE) $(build)=scripts/kconfig $@
576
577 else
578 # ===========================================================================
579 # Build targets only - this includes vmlinux, arch specific targets, clean
580 # targets and others. In general all targets except *config targets.
581
582 # Additional helpers built in scripts/
583 # Carefully list dependencies so we do not try to build scripts twice
584 # in parallel
585 PHONY += scripts
586 scripts: scripts_basic scripts_dtc include/config/auto.conf
587 $(Q)$(MAKE) $(build)=$(@)
588
589 ifeq ($(dot-config),1)
590 # Read in config
591 -include include/config/auto.conf
592
593 # Read in dependencies to all Kconfig* files, make sure to run
594 # oldconfig if changes are detected.
595 -include include/config/auto.conf.cmd
596
597 # To avoid any implicit rule to kick in, define an empty command
598 $(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
599
600 # If .config is newer than include/config/auto.conf, someone tinkered
601 # with it and forgot to run make oldconfig.
602 # if auto.conf.cmd is missing then we are probably in a cleaned tree so
603 # we execute the config step to be sure to catch updated Kconfig files
604 include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
605 $(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
606 @# If the following part fails, include/config/auto.conf should be
607 @# deleted so "make silentoldconfig" will be re-run on the next build.
608 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
609 { rm -f include/config/auto.conf; false; }
610 @# include/config.h has been updated after "make silentoldconfig".
611 @# We need to touch include/config/auto.conf so it gets newer
612 @# than include/config.h.
613 @# Otherwise, 'make silentoldconfig' would be invoked twice.
614 $(Q)touch include/config/auto.conf
615
616 u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
617 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
618
619 -include include/autoconf.mk
620 -include include/autoconf.mk.dep
621
622 # We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
623 # is up-to-date. When we switch to a different board configuration, old CONFIG
624 # macros are still remaining in include/config/auto.conf. Without the following
625 # gimmick, wrong config.mk would be included leading nasty warnings/errors.
626 ifneq ($(wildcard $(KCONFIG_CONFIG)),)
627 ifneq ($(wildcard include/config/auto.conf),)
628 autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
629 include/config/auto.conf)
630 ifeq ($(autoconf_is_old),)
631 include config.mk
632 include arch/$(ARCH)/Makefile
633 endif
634 endif
635 endif
636
637 # These are set by the arch-specific config.mk. Make sure they are exported
638 # so they can be used when building an EFI application.
639 export EFI_LDS # Filename of EFI link script in arch/$(ARCH)/lib
640 export EFI_CRT0 # Filename of EFI CRT0 in arch/$(ARCH)/lib
641 export EFI_RELOC # Filename of EFU relocation code in arch/$(ARCH)/lib
642 export CFLAGS_EFI # Compiler flags to add when building EFI app
643 export CFLAGS_NON_EFI # Compiler flags to remove when building EFI app
644 export EFI_TARGET # binutils target if EFI is natively supported
645
646 export LTO_ENABLE
647
648 # This is y if LTO is enabled for this build. See NO_LTO=1 to disable LTO
649 ifeq ($(NO_LTO),)
650 LTO_ENABLE=$(if $(CONFIG_LTO),y)
651 endif
652
653 # If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
654 # that (or fail if absent). Otherwise, search for a linker script in a
655 # standard location.
656
657 ifndef LDSCRIPT
658 #LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
659 ifdef CONFIG_SYS_LDSCRIPT
660 # need to strip off double quotes
661 LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
662 endif
663 endif
664
665 # If there is no specified link script, we look in a number of places for it
666 ifndef LDSCRIPT
667 ifeq ($(wildcard $(LDSCRIPT)),)
668 LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
669 endif
670 ifeq ($(wildcard $(LDSCRIPT)),)
671 LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
672 endif
673 ifeq ($(wildcard $(LDSCRIPT)),)
674 LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
675 endif
676 endif
677
678 else
679 # Dummy target needed, because used as prerequisite
680 include/config/auto.conf: ;
681 endif # $(dot-config)
682
683 ifdef CONFIG_CC_OPTIMIZE_FOR_DEBUG
684 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -Og -g -fomit-frame-pointer \
685 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
686 # Avoid false positives -Wmaybe-uninitialized
687 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78394
688 KBUILD_HOSTCFLAGS += -Wno-maybe-uninitialized
689 KBUILD_HOSTCXXFLAGS := -Og -g $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
690 endif
691
692 #
693 # Xtensa linker script cannot be preprocessed with -ansi because of
694 # preprocessor operations on strings that don't make C identifiers.
695 #
696 ifeq ($(CONFIG_XTENSA),)
697 LDPPFLAGS += -ansi
698 endif
699
700 ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
701 KBUILD_CFLAGS += -Os
702 endif
703
704 ifdef CONFIG_CC_OPTIMIZE_FOR_SPEED
705 KBUILD_CFLAGS += -O2
706 endif
707
708 ifdef CONFIG_CC_OPTIMIZE_FOR_DEBUG
709 KBUILD_CFLAGS += -Og -Wno-maybe-uninitialized
710 # Avoid false positives -Wmaybe-uninitialized
711 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78394
712 KBUILD_CFLAGS += -Wno-maybe-uninitialized
713 endif
714
715 LTO_CFLAGS :=
716 LTO_FINAL_LDFLAGS :=
717 export LTO_CFLAGS LTO_FINAL_LDFLAGS
718 ifeq ($(LTO_ENABLE),y)
719 ifeq ($(cc-name),clang)
720 LTO_CFLAGS += -DLTO_ENABLE -flto
721 LTO_FINAL_LDFLAGS += -flto
722
723 AR = $(shell $(CC) -print-prog-name=llvm-ar)
724 NM = $(shell $(CC) -print-prog-name=llvm-nm)
725 else
726 NPROC := $(shell nproc 2>/dev/null || echo 1)
727 LTO_CFLAGS += -DLTO_ENABLE -flto=$(NPROC)
728 LTO_FINAL_LDFLAGS += -fuse-linker-plugin -flto=$(NPROC)
729
730 # use plugin aware tools
731 AR = $(CROSS_COMPILE)gcc-ar
732 NM = $(CROSS_COMPILE)gcc-nm
733 endif
734
735 CFLAGS_NON_EFI += $(LTO_CFLAGS)
736
737 KBUILD_CFLAGS += $(LTO_CFLAGS)
738 endif
739
740 ifeq ($(CONFIG_STACKPROTECTOR),y)
741 KBUILD_CFLAGS += $(call cc-option,-fstack-protector-strong)
742 CFLAGS_EFI += $(call cc-option,-fno-stack-protector)
743 else
744 KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
745 endif
746 KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
747
748 # disable pointer signed / unsigned warnings in gcc 4.0
749 KBUILD_CFLAGS += -Wno-pointer-sign
750
751 # disable stringop warnings in gcc 8+
752 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
753
754 KBUILD_CFLAGS += $(call cc-disable-warning, zero-length-bounds)
755 KBUILD_CFLAGS += $(call cc-disable-warning, array-bounds)
756 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-overflow)
757
758 # Enabled with W=2, disabled by default as noisy
759 KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
760
761 # change __FILE__ to the relative path from the srctree
762 KBUILD_CFLAGS += $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
763
764 KBUILD_CFLAGS += -g
765 # $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
766 # option to the assembler.
767 KBUILD_AFLAGS += -g
768
769 # Report stack usage if supported
770 # ARC tools based on GCC 7.1 has an issue with stack usage
771 # with naked functions, see commit message for more details
772 ifndef CONFIG_ARC
773 ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
774 KBUILD_CFLAGS += -fstack-usage
775 endif
776 endif
777
778 KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
779 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
780
781 ifdef CONFIG_CC_IS_CLANG
782 KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
783 KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
784 KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
785 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
786 # Quiet clang warning: comparison of unsigned expression < 0 is always false
787 KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
788 # CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
789 # source of a reference will be _MergedGlobals and not on of the whitelisted names.
790 # See modpost pattern 2
791 KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
792 KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
793 endif
794
795 # These warnings generated too much noise in a regular build.
796 # Use make W=1 to enable them (see scripts/Makefile.extrawarn)
797 KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
798
799 # Prohibit date/time macros, which would make the build non-deterministic
800 KBUILD_CFLAGS += $(call cc-option,-Werror=date-time)
801
802 include scripts/Makefile.extrawarn
803
804 # Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
805 KBUILD_CPPFLAGS += $(KCPPFLAGS)
806 KBUILD_AFLAGS += $(KAFLAGS)
807 KBUILD_CFLAGS += $(KCFLAGS)
808
809 KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
810
811 # Use UBOOTINCLUDE when you must reference the include/ directory.
812 # Needed to be compatible with the O= option
813 UBOOTINCLUDE := \
814 -Iinclude \
815 $(if $(KBUILD_SRC), -I$(srctree)/include) \
816 $(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
817 $(if $(CONFIG_HAS_THUMB2), \
818 $(if $(CONFIG_CPU_V7M), \
819 -I$(srctree)/arch/arm/thumb1/include), \
820 -I$(srctree)/arch/arm/thumb1/include)) \
821 -I$(srctree)/arch/$(ARCH)/include \
822 -include $(srctree)/include/linux/kconfig.h
823
824 NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
825
826 # FIX ME
827 cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
828 $(NOSTDINC_FLAGS)
829 c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
830
831 #########################################################################
832 # U-Boot objects....order is important (i.e. start must be first)
833
834 HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
835
836 libs-$(CONFIG_API) += api/
837 libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
838 libs-y += boot/
839 libs-y += cmd/
840 libs-y += common/
841 libs-$(CONFIG_OF_EMBED) += dts/
842 libs-y += env/
843 libs-y += lib/
844 libs-y += fs/
845 libs-y += net/
846 libs-y += disk/
847 libs-y += drivers/
848 libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
849 libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
850 libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
851 libs-y += drivers/usb/cdns3/
852 libs-y += drivers/usb/dwc3/
853 libs-y += drivers/usb/common/
854 libs-y += drivers/usb/emul/
855 libs-y += drivers/usb/eth/
856 libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
857 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
858 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
859 libs-y += drivers/usb/host/
860 libs-y += drivers/usb/mtu3/
861 libs-y += drivers/usb/musb/
862 libs-y += drivers/usb/musb-new/
863 libs-y += drivers/usb/isp1760/
864 libs-y += drivers/usb/phy/
865 libs-y += drivers/usb/ulpi/
866 ifdef CONFIG_POST
867 libs-y += post/
868 endif
869 libs-$(CONFIG_$(SPL_TPL_)UNIT_TEST) += test/
870 libs-$(CONFIG_UT_ENV) += test/env/
871 libs-$(CONFIG_UT_OPTEE) += test/optee/
872 libs-$(CONFIG_UT_OVERLAY) += test/overlay/
873
874 libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
875
876 libs-y := $(sort $(libs-y))
877
878 u-boot-dirs := $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
879
880 u-boot-alldirs := $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
881
882 libs-y := $(patsubst %/, %/built-in.o, $(libs-y))
883
884 u-boot-init := $(head-y)
885 u-boot-main := $(libs-y)
886
887
888 # Add GCC lib
889 ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
890 PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
891 else
892 PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
893 endif
894 PLATFORM_LIBS += $(PLATFORM_LIBGCC)
895
896 ifdef CONFIG_CC_COVERAGE
897 KBUILD_CFLAGS += --coverage
898 PLATFORM_LIBGCC += -lgcov
899 endif
900
901 export PLATFORM_LIBS
902 export PLATFORM_LIBGCC
903
904 # Special flags for CPP when processing the linker script.
905 # Pass the version down so we can handle backwards compatibility
906 # on the fly.
907 LDPPFLAGS += \
908 -include $(srctree)/include/u-boot/u-boot.lds.h \
909 -DCPUDIR=$(CPUDIR) \
910 $(shell $(LD) --version | \
911 sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
912
913 #########################################################################
914 #########################################################################
915
916 ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
917 BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
918 else
919 BOARD_SIZE_CHECK =
920 endif
921
922 ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
923 SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
924 else
925 SPL_SIZE_CHECK =
926 endif
927
928 ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
929 TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
930 else
931 TPL_SIZE_CHECK =
932 endif
933
934 ifneq ($(CONFIG_VPL_SIZE_LIMIT),0x0)
935 VPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_VPL_SIZE_LIMIT))
936 else
937 VPL_SIZE_CHECK =
938 endif
939
940 # Statically apply RELA-style relocations (currently arm64 only)
941 # This is useful for arm64 where static relocation needs to be performed on
942 # the raw binary, but certain simulators only accept an ELF file (but don't
943 # do the relocation).
944 ifneq ($(CONFIG_STATIC_RELA),)
945 # $(2) is u-boot ELF, $(3) is u-boot bin, $(4) is text base
946 quiet_cmd_static_rela = RELOC $@
947 cmd_static_rela = \
948 tools/relocate-rela $(3) $(2)
949 else
950 quiet_cmd_static_rela =
951 cmd_static_rela =
952 endif
953
954 # Always append INPUTS so that arch config.mk's can add custom ones
955 INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
956
957 INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
958 ifeq ($(CONFIG_SPL_FSL_PBL),y)
959 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
960 else
961 ifneq ($(CONFIG_NXP_ESBC), y)
962 # For Secure Boot The Image needs to be signed and Header must also
963 # be included. So The image has to be built explicitly
964 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
965 endif
966 endif
967 INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
968 ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
969 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
970 else
971 ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
972 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
973 else
974 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
975 endif
976 endif
977 INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
978 INPUTS-$(CONFIG_VPL) += vpl/u-boot-vpl.bin
979
980 # Allow omitting the .dtb output if it is not normally used
981 INPUTS-$(CONFIG_OF_SEPARATE) += $(if $(CONFIG_OF_OMIT_DTB),dts/dt.dtb,u-boot.dtb)
982 ifeq ($(CONFIG_SPL_FRAMEWORK),y)
983 INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
984 endif
985 INPUTS-$(CONFIG_SANDBOX) += u-boot.dtb
986 ifneq ($(CONFIG_SPL_TARGET),)
987 INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
988 endif
989 INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
990 INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
991 INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
992
993 # Generate this input file for binman
994 ifeq ($(CONFIG_SPL),)
995 INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
996 endif
997
998 # Add optional build target if defined in board/cpu/soc headers
999 ifneq ($(CONFIG_BUILD_TARGET),)
1000 INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
1001 endif
1002
1003 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1004 INPUTS-y += init_sp_bss_offset_check
1005 endif
1006
1007 ifeq ($(CONFIG_ARCH_ROCKCHIP)$(CONFIG_SPL),yy)
1008 # Binman image dependencies
1009 ifeq ($(CONFIG_ARM64),y)
1010 INPUTS-y += u-boot.itb
1011 else
1012 INPUTS-y += u-boot.img
1013 endif
1014 endif
1015
1016 INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
1017 $(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
1018 $(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
1019
1020 LDFLAGS_u-boot += $(LDFLAGS_FINAL)
1021
1022 # Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
1023 LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
1024
1025 # ld.lld support
1026 LDFLAGS_u-boot += -z notext $(call ld-option,--apply-dynamic-relocs)
1027
1028 LDFLAGS_u-boot += --build-id=none
1029
1030 ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
1031 LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
1032 endif
1033
1034 # insure the checker run with the right endianness
1035 CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
1036
1037 # the checker needs the correct machine size
1038 CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
1039
1040 # Normally we fill empty space with 0xff
1041 quiet_cmd_objcopy = OBJCOPY $@
1042 cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
1043 $(OBJCOPYFLAGS_$(@F)) $< $@
1044
1045 # Provide a version which does not do this, for use by EFI
1046 quiet_cmd_zobjcopy = OBJCOPY $@
1047 cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
1048
1049 quiet_cmd_efipayload = OBJCOPY $@
1050 cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
1051
1052 MKIMAGEOUTPUT ?= /dev/null
1053
1054 quiet_cmd_mkimage = MKIMAGE $@
1055 cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1056 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1057
1058 quiet_cmd_mkfitimage = MKIMAGE $@
1059 cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
1060 -f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1061 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1062
1063 quiet_cmd_cat = CAT $@
1064 cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1065
1066 append = cat $(filter-out $< $(PHONY), $^) >> $@
1067
1068 quiet_cmd_pad_cat = CAT $@
1069 cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1070
1071 quiet_cmd_lzma = LZMA $@
1072 cmd_lzma = lzma -c -z -k -9 $< > $@
1073
1074 cfg: u-boot.cfg
1075
1076 quiet_cmd_cfgcheck = CFGCHK $2
1077 cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1078 $(srctree)/scripts/config_whitelist.txt $(srctree)
1079
1080 quiet_cmd_ofcheck = OFCHK $2
1081 cmd_ofcheck = $(srctree)/scripts/check-of.sh $2 \
1082 $(srctree)/scripts/of_allowlist.txt
1083
1084 # Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
1085 got = $(foreach cfg,$(1),$($(cfg)))
1086
1087 # expected value 'y for each one
1088 expect = $(foreach cfg,$(1),y)
1089
1090 # Show a deprecation message
1091 # Args:
1092 # 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
1093 # 2: Name of component (e.g . "Ethernet drivers")
1094 # 3: Release deadline (e.g. "v202.07")
1095 # 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
1096 # Note: Script avoids bash construct, hence the strange double 'if'
1097 # (patches welcome!)
1098 define deprecated
1099 @if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1100 echo >&2 "===================== WARNING ======================"; \
1101 echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
1102 echo >&2 "for $(2)). Please update the board to use"; \
1103 echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
1104 echo >&2 "update by the deadline may result in board removal."; \
1105 echo >&2 "See doc/develop/driver-model/migration.rst for more info."; \
1106 echo >&2 "===================================================="; \
1107 fi; fi
1108
1109 endef
1110
1111 PHONY += inputs
1112 inputs: $(INPUTS-y)
1113
1114 all: .binman_stamp inputs
1115 ifeq ($(CONFIG_BINMAN),y)
1116 $(call if_changed,binman)
1117 endif
1118
1119 # Timestamp file to make sure that binman always runs
1120 .binman_stamp: FORCE
1121 @touch $@
1122
1123 ifeq ($(CONFIG_DEPRECATED),y)
1124 $(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1125 endif
1126 ifeq ($(CONFIG_OF_EMBED)$(CONFIG_EFI_APP),y)
1127 @echo >&2 "===================== WARNING ======================"
1128 @echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1129 @echo >&2 "be used for debugging purposes. Please use"
1130 @echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1131 @echo >&2 "See doc/develop/devicetree/control.rst for more info."
1132 @echo >&2 "===================================================="
1133 endif
1134 ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1135 @echo >&2 "===================== WARNING ======================"
1136 @echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1137 @echo >&2 "to binman instead, to avoid the proliferation of"
1138 @echo >&2 "arch-specific scripts with no tests."
1139 @echo >&2 "===================================================="
1140 endif
1141 ifneq ($(CONFIG_DM),y)
1142 @echo >&2 "===================== WARNING ======================"
1143 @echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1144 @echo >&2 "compulsory starting with the v2020.01 release."
1145 @echo >&2 "Failure to update may result in board removal."
1146 @echo >&2 "See doc/develop/driver-model/migration.rst for more info."
1147 @echo >&2 "===================================================="
1148 endif
1149 $(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
1150 $(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1151 $(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_SYS_I2C_LEGACY))
1152 $(call deprecated,CONFIG_DM_KEYBOARD,Keyboard drivers,v2022.10,$(CONFIG_KEYBOARD))
1153 @# CONFIG_SYS_TIMER_RATE has brackets in it for some boards which
1154 @# confuses this rule. Use if() to send just a single character which
1155 @# is enable to tell 'deprecated' that one of these symbols exists
1156 $(call deprecated,CONFIG_TIMER,Timer drivers,v2023.01,$(if $(strip $(CONFIG_SYS_TIMER_RATE)$(CONFIG_SYS_TIMER_COUNTER)),x))
1157 $(call deprecated,CONFIG_DM_SERIAL,Serial drivers,v2023.04,$(CONFIG_SERIAL))
1158 $(call deprecated,CONFIG_DM_SCSI,SCSI drivers,v2023.04,$(CONFIG_SCSI))
1159 @# Check that this build does not use CONFIG options that we do not
1160 @# know about unless they are in Kconfig. All the existing CONFIG
1161 @# options are whitelisted, so new ones should not be added.
1162 $(call cmd,cfgcheck,u-boot.cfg)
1163 @# Check that this build does not override OF_HAS_PRIOR_STAGE by
1164 @# disabling OF_BOARD.
1165 $(call cmd,ofcheck,$(KCONFIG_CONFIG))
1166
1167 PHONY += dtbs
1168 dtbs: dts/dt.dtb
1169 @:
1170 dts/dt.dtb: u-boot
1171 $(Q)$(MAKE) $(build)=dts dtbs
1172
1173 quiet_cmd_copy = COPY $@
1174 cmd_copy = cp $< $@
1175
1176 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1177
1178 ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1179 FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1180 else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1181 FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1182 else
1183 FINAL_DTB_CONTAINER = fit-dtb.blob
1184 endif
1185
1186 fit-dtb.blob.gz: fit-dtb.blob
1187 @gzip -kf9 $< > $@
1188
1189 fit-dtb.blob.lzo: fit-dtb.blob
1190 @lzop -f9 $< > $@
1191
1192 fit-dtb.blob: dts/dt.dtb FORCE
1193 $(call if_changed,mkimage)
1194 ifneq ($(SOURCE_DATE_EPOCH),)
1195 touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1196 chmod 0600 fit-dtb.blob
1197 endif
1198
1199 MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1200 -a 0 -e 0 -E \
1201 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1202
1203 MKIMAGEFLAGS_fit-dtb.blob += -B 0x8
1204
1205 ifneq ($(EXT_DTB),)
1206 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1207 $(call if_changed,cat)
1208 else
1209 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1210 $(call if_changed,cat)
1211 endif
1212
1213 u-boot.bin: u-boot-fit-dtb.bin FORCE
1214 $(call if_changed,copy)
1215
1216 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1217 $(call if_changed,cat)
1218
1219 else ifeq ($(CONFIG_OF_SEPARATE).$(CONFIG_OF_OMIT_DTB),y.)
1220 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1221 $(call if_changed,cat)
1222
1223 ifneq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR)$(CONFIG_OF_SEPARATE),yy)
1224 u-boot.bin: u-boot-dtb.bin FORCE
1225 $(call if_changed,copy)
1226 endif
1227
1228 else ifneq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR)$(CONFIG_OF_SEPARATE),yy)
1229 u-boot.bin: u-boot-nodtb.bin FORCE
1230 $(call if_changed,copy)
1231 endif
1232
1233 # we call Makefile in arch/arm/mach-imx which
1234 # has targets which are dependent on targets defined
1235 # here. make could not resolve them and we must ensure
1236 # that they are finished before calling imx targets
1237 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1238 IMX_DEPS = u-boot-fit-dtb.bin
1239 endif
1240
1241 %.imx: $(IMX_DEPS) %.bin
1242 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1243 $(BOARD_SIZE_CHECK)
1244
1245 %.vyb: %.imx
1246 $(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1247
1248 quiet_cmd_copy = COPY $@
1249 cmd_copy = cp $< $@
1250
1251 u-boot.dtb: dts/dt.dtb
1252 $(call cmd,copy)
1253
1254 OBJCOPYFLAGS_u-boot.hex := -O ihex
1255
1256 OBJCOPYFLAGS_u-boot.srec := -O srec
1257
1258 u-boot.hex u-boot.srec: u-boot FORCE
1259 $(call if_changed,objcopy)
1260
1261 OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1262
1263 u-boot-elf.srec: u-boot.elf FORCE
1264 $(call if_changed,objcopy)
1265
1266 OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1267
1268 spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1269 $(call if_changed,objcopy)
1270
1271 %.scif: %.srec
1272 $(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1273
1274 OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1275 $(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1276 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),$(if $(CONFIG_OF_SEPARATE),-R .bootpg -R .resetvec))
1277
1278 binary_size_check: u-boot-nodtb.bin FORCE
1279 @file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1280 map_size=$(shell cat u-boot.map | \
1281 awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1282 | sed 's/0X//g' \
1283 | bc); \
1284 if [ "" != "$$map_size" ]; then \
1285 if test $$map_size -ne $$file_size; then \
1286 echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1287 echo " but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1288 exit 1; \
1289 fi; \
1290 fi
1291
1292 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1293 ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1294 subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1295 else
1296 subtract_sys_malloc_f_len = true
1297 endif
1298 # The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1299 # so low that the DTB could probably use 90%+ of the available space, for
1300 # current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1301 # safe for now and tweak this later if space becomes tight.
1302 # A rejected alternative would be to check that some absolute minimum stack
1303 # space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1304 # deliberately build-specific, to take account of build-to-build stack usage
1305 # differences due to different feature sets, there is no common absolute value
1306 # to check against.
1307 init_sp_bss_offset_check: u-boot.dtb FORCE
1308 @dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1309 space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1310 $(subtract_sys_malloc_f_len) ; \
1311 quarter_space=$$(($${space} / 4)) ; \
1312 if [ $${dtb_size} -gt $${quarter_space} ]; then \
1313 echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1314 echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1315 exit 1 ; \
1316 fi
1317 endif
1318
1319 shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1320
1321 quiet_cmd_objcopy_uboot = OBJCOPY $@
1322 ifdef cmd_static_rela
1323 cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1324 else
1325 cmd_objcopy_uboot = $(cmd_objcopy)
1326 endif
1327
1328 u-boot-nodtb.bin: u-boot FORCE
1329 $(call if_changed,objcopy_uboot)
1330 $(BOARD_SIZE_CHECK)
1331
1332 u-boot.ldr: u-boot
1333 $(CREATE_LDR_ENV)
1334 $(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1335 $(BOARD_SIZE_CHECK)
1336
1337 # binman
1338 # ---------------------------------------------------------------------------
1339 # Use 'make BINMAN_DEBUG=1' to enable debugging
1340 # Use 'make BINMAN_VERBOSE=3' to set vebosity level
1341 default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1342
1343 quiet_cmd_binman = BINMAN $@
1344 cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1345 $(foreach f,$(BINMAN_TOOLPATHS),--toolpath $(f)) \
1346 --toolpath $(objtree)/tools \
1347 $(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1348 build -u -d u-boot.dtb -O . -m --allow-missing \
1349 --fake-ext-blobs \
1350 -I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1351 -I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1352 $(foreach f,$(BINMAN_INDIRS),-I $(f)) \
1353 -a atf-bl31-path=${BL31} \
1354 -a tee-os-path=${TEE} \
1355 -a opensbi-path=${OPENSBI} \
1356 -a default-dt=$(default_dt) \
1357 -a scp-path=$(SCP) \
1358 -a spl-bss-pad=$(if $(CONFIG_SPL_SEPARATE_BSS),,1) \
1359 -a tpl-bss-pad=$(if $(CONFIG_TPL_SEPARATE_BSS),,1) \
1360 -a spl-dtb=$(CONFIG_SPL_OF_REAL) \
1361 -a tpl-dtb=$(CONFIG_TPL_OF_REAL) \
1362 -a pre-load-key-path=${PRE_LOAD_KEY_PATH} \
1363 $(BINMAN_$(@F))
1364
1365 OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1366
1367 OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1368
1369 u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1370 $(call if_changed,objcopy)
1371
1372 #
1373 # U-Boot entry point, needed for booting of full-blown U-Boot
1374 # from the SPL U-Boot version.
1375 #
1376 ifndef CONFIG_SYS_UBOOT_START
1377 CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1378 endif
1379
1380 # Boards with more complex image requirements can provide an .its source file
1381 # or a generator script
1382 # NOTE: Please do not use this. We are migrating away from Makefile rules to use
1383 # binman instead.
1384 ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1385 U_BOOT_ITS := u-boot.its
1386 $(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1387 $(call if_changed,copy)
1388 else
1389 ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1390 U_BOOT_ITS := u-boot.its
1391 ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1392 U_BOOT_ITS_DEPS += u-boot
1393 endif
1394 $(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1395 $(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1396 $(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1397 endif
1398 endif
1399
1400 ifdef CONFIG_SPL_LOAD_FIT
1401 MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1402 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1403 -p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1404 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1405 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1406 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1407 $(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1408 else
1409 MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1410 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1411 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1412 MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1413 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1414 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1415 u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1416 endif
1417
1418 MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1419
1420 # Some boards have the kwbimage.cfg file written in advance, while some
1421 # other boards generate it on the fly during the build in the build tree.
1422 # Let's check if the file exists in the build tree first, otherwise we
1423 # fall back to use the one in the source tree.
1424 KWD_CONFIG_FILE = $(shell \
1425 if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1426 echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1427 else \
1428 echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1429 fi)
1430
1431 MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1432 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1433
1434 MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1435 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1436 $(if $(KEYDIR),-k $(KEYDIR))
1437
1438 MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1439 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -A $(ARCH) -T pblimage
1440
1441 UBOOT_BIN := u-boot.bin
1442
1443 MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1444 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1445 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1446
1447 u-boot.bin.lzma: u-boot.bin FORCE
1448 $(call if_changed,lzma)
1449
1450 u-boot-lzma.img: u-boot.bin.lzma FORCE
1451 $(call if_changed,mkimage)
1452
1453 u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1454 $(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1455 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1456 ,$(UBOOT_BIN)) FORCE
1457 $(call if_changed,mkimage)
1458 $(BOARD_SIZE_CHECK)
1459
1460 ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1461 MKIMAGEFLAGS_u-boot.itb =
1462 else
1463 MKIMAGEFLAGS_u-boot.itb = -E
1464 endif
1465 MKIMAGEFLAGS_u-boot.itb += -B 0x8
1466
1467 ifdef U_BOOT_ITS
1468 u-boot.itb: u-boot-nodtb.bin \
1469 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1470 $(U_BOOT_ITS) FORCE
1471 $(call if_changed,mkfitimage)
1472 $(BOARD_SIZE_CHECK)
1473 endif
1474
1475 u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
1476 $(call if_changed,mkimage)
1477 $(BOARD_SIZE_CHECK)
1478
1479 u-boot.sha1: u-boot.bin
1480 tools/ubsha1 u-boot.bin
1481
1482 u-boot.dis: u-boot
1483 $(OBJDUMP) -d $< > $@
1484
1485 ifneq ($(CONFIG_SPL_PAYLOAD),)
1486 SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1487 else
1488 SPL_PAYLOAD := u-boot.bin
1489 endif
1490
1491 SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1492
1493 OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1494 --pad-to=$(CONFIG_SPL_PAD_TO)
1495 u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1496 $(call if_changed,pad_cat)
1497
1498
1499 ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1500 MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1501
1502 lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1503 $(call if_changed,mkimage)
1504
1505 OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1506
1507 lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1508 $(call if_changed,objcopy)
1509
1510 OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1511
1512 lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1513 $(call if_changed,objcopy)
1514
1515 lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1516 $(call if_changed,cat)
1517
1518 endif
1519
1520 OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1521 --pad-to=$(CONFIG_TPL_PAD_TO)
1522 tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1523 $(call if_changed,pad_cat)
1524
1525 SPL: spl/u-boot-spl.bin FORCE
1526 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1527
1528 #ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
1529 ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1530 u-boot.cnt: u-boot.bin FORCE
1531 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1532
1533 flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1534 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1535 else
1536 ifeq ($(CONFIG_BINMAN),y)
1537 flash.bin: spl/u-boot-spl.bin $(INPUTS-y) FORCE
1538 $(call if_changed,binman)
1539 else
1540 flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1541 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1542 endif
1543 endif
1544 #endif
1545
1546 u-boot.uim: u-boot.bin FORCE
1547 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1548
1549 u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1550 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1551
1552 MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1553
1554 u-boot.ubl: u-boot-with-spl.bin FORCE
1555 $(call if_changed,mkimage)
1556
1557 MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1558 $(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1559 -T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1560 spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1561 $(call if_changed,mkimage)
1562
1563 OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1564 u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1565 $(call if_changed,pad_cat)
1566
1567 u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1568 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1569 u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1570 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1571
1572 MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1573 -a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1574 spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1575 $(call if_changed,mkimage)
1576
1577 ifneq ($(CONFIG_ARCH_SOCFPGA),)
1578 quiet_cmd_gensplx4 = GENSPLX4 $@
1579 cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0 \
1580 --pad-to=$(CONFIG_SPL_PAD_TO) \
1581 spl/u-boot-spl.sfp spl/u-boot-spl.sfp && \
1582 cat spl/u-boot-spl.sfp spl/u-boot-spl.sfp \
1583 spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1584 spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1585 $(call if_changed,gensplx4)
1586
1587 quiet_cmd_socboot = SOCBOOT $@
1588 cmd_socboot = cat spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1589 u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1590 $(call if_changed,socboot)
1591
1592 quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1593 cmd_gensplpadx4 = dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1594 cat spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1595 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1596 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1597 spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1598 { rm -f $@ spl/u-boot-spl.pad; false; }
1599 u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1600 $(call if_changed,gensplpadx4)
1601
1602 quiet_cmd_socnandboot = SOCNANDBOOT $@
1603 cmd_socnandboot = cat u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1604 u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1605 $(call if_changed,socnandboot)
1606
1607 endif
1608
1609 ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR)$(CONFIG_OF_SEPARATE),yy)
1610 u-boot.bin: u-boot-nodtb.bin u-boot.dtb u-boot-br.bin FORCE
1611 $(call if_changed,binman)
1612
1613 OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1614 u-boot-br.bin: u-boot FORCE
1615 $(call if_changed,objcopy)
1616 endif
1617
1618 quiet_cmd_ldr = LD $@
1619 cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1620 $(filter-out FORCE,$^) -o $@
1621
1622 ifdef CONFIG_X86
1623 OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1624 u-boot-x86-start16.bin: u-boot FORCE
1625 $(call if_changed,objcopy)
1626
1627 OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1628 u-boot-x86-reset16.bin: u-boot FORCE
1629 $(call if_changed,objcopy)
1630
1631 endif # CONFIG_X86
1632
1633 OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1634 u-boot-app.efi: u-boot FORCE
1635 $(call if_changed,zobjcopy)
1636
1637 u-boot.bin.o: u-boot.bin FORCE
1638 $(call if_changed,efipayload)
1639
1640 u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1641 $(call if_changed_dep,cpp_lds)
1642
1643 # Rule to link the EFI payload which contains a stub and a U-Boot binary
1644 quiet_cmd_u-boot_payload ?= LD $@
1645 cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
1646 -T u-boot-payload.lds arch/x86/cpu/call32.o \
1647 lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1648 $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1649
1650 u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1651 $(call if_changed,u-boot_payload)
1652
1653 OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1654 u-boot-payload.efi: u-boot-payload FORCE
1655 $(call if_changed,zobjcopy)
1656
1657 u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1658 $(call if_changed,cat)
1659
1660 #Add a target to create boot binary having SPL binary in PBI format
1661 #concatenated with u-boot binary. It is need by PowerPC SoC having
1662 #internal SRAM <= 512KB.
1663 MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1664 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1665 -A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1666
1667 spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1668 $(call if_changed,mkimage)
1669
1670 ifeq ($(ARCH),arm)
1671 UBOOT_BINLOAD := u-boot.img
1672 else
1673 UBOOT_BINLOAD := u-boot.bin
1674 endif
1675
1676 OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1677 --gap-fill=0xff
1678
1679 u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1680 $(call if_changed,pad_cat)
1681
1682 # PPC4xx needs the SPL at the end of the image, since the reset vector
1683 # is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1684 # and need to introduce a new build target with the full blown U-Boot
1685 # at the start padded up to the start of the SPL image. And then concat
1686 # the SPL image to the end.
1687
1688 OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1689 --pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1690 u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1691 $(call if_changed,pad_cat)
1692
1693 quiet_cmd_u-boot-elf ?= LD $@
1694 cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1695 $(if $(CONFIG_SYS_BIG_ENDIAN),-EB,-EL) \
1696 -T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1697 -Ttext=$(CONFIG_SYS_TEXT_BASE)
1698 u-boot.elf: u-boot.bin u-boot-elf.lds
1699 $(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1700 $(call if_changed,u-boot-elf)
1701
1702 u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1703 $(call if_changed_dep,cpp_lds)
1704
1705 # MediaTek's ARM-based u-boot needs a header to contains its load address
1706 # which is parsed by the BootROM.
1707 # If the SPL build is enabled, the header will be added to the spl binary,
1708 # and the spl binary and the u-boot.img will be combined into one file.
1709 # Otherwise the header will be added to the u-boot.bin directly.
1710
1711 ifeq ($(CONFIG_SPL),y)
1712 spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1713
1714 u-boot-mtk.bin: u-boot-with-spl.bin
1715 $(call if_changed,copy)
1716 else
1717 MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1718 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1719 -n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1720
1721 u-boot-mtk.bin: u-boot.bin FORCE
1722 $(call if_changed,mkimage)
1723 endif
1724
1725 quiet_cmd_endian_swap = SWAP $@
1726 cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1727
1728 u-boot-swap.bin: u-boot.bin FORCE
1729 $(call if_changed,endian_swap)
1730
1731 ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1732
1733 # Generate linker list symbols references to force compiler to not optimize
1734 # them away when compiling with LTO
1735 ifeq ($(LTO_ENABLE),y)
1736 u-boot-keep-syms-lto := keep-syms-lto.o
1737 u-boot-keep-syms-lto_c := $(patsubst %.o,%.c,$(u-boot-keep-syms-lto))
1738
1739 quiet_cmd_keep_syms_lto = KSL $@
1740 cmd_keep_syms_lto = \
1741 $(srctree)/scripts/gen_ll_addressable_symbols.sh $(NM) $^ > $@
1742
1743 quiet_cmd_keep_syms_lto_cc = KSLCC $@
1744 cmd_keep_syms_lto_cc = \
1745 $(CC) $(filter-out $(LTO_CFLAGS),$(c_flags)) -c -o $@ $<
1746
1747 $(u-boot-keep-syms-lto_c): $(u-boot-main)
1748 $(call if_changed,keep_syms_lto)
1749 $(u-boot-keep-syms-lto): $(u-boot-keep-syms-lto_c)
1750 $(call if_changed,keep_syms_lto_cc)
1751 else
1752 u-boot-keep-syms-lto :=
1753 endif
1754
1755 # Rule to link u-boot
1756 # May be overridden by arch/$(ARCH)/config.mk
1757 ifeq ($(LTO_ENABLE),y)
1758 quiet_cmd_u-boot__ ?= LTO $@
1759 cmd_u-boot__ ?= \
1760 $(CC) -nostdlib -nostartfiles \
1761 $(LTO_FINAL_LDFLAGS) $(c_flags) \
1762 $(KBUILD_LDFLAGS:%=-Wl,%) $(LDFLAGS_u-boot:%=-Wl,%) -o $@ \
1763 -T u-boot.lds $(u-boot-init) \
1764 -Wl,--whole-archive \
1765 $(u-boot-main) \
1766 $(u-boot-keep-syms-lto) \
1767 $(PLATFORM_LIBS) \
1768 -Wl,--no-whole-archive \
1769 -Wl,-Map,u-boot.map; \
1770 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1771 else
1772 quiet_cmd_u-boot__ ?= LD $@
1773 cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1774 -T u-boot.lds $(u-boot-init) \
1775 --whole-archive \
1776 $(u-boot-main) \
1777 --no-whole-archive \
1778 $(PLATFORM_LIBS) -Map u-boot.map; \
1779 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1780 endif
1781
1782 quiet_cmd_smap = GEN common/system_map.o
1783 cmd_smap = \
1784 smap=`$(call SYSTEM_MAP,u-boot) | \
1785 awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1786 $(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1787 -c $(srctree)/common/system_map.c -o common/system_map.o
1788
1789 u-boot: $(u-boot-init) $(u-boot-main) $(u-boot-keep-syms-lto) u-boot.lds FORCE
1790 +$(call if_changed,u-boot__)
1791 ifeq ($(CONFIG_KALLSYMS),y)
1792 $(call cmd,smap)
1793 $(call cmd,u-boot__) common/system_map.o
1794 endif
1795
1796 ifeq ($(CONFIG_RISCV),y)
1797 @tools/prelink-riscv $@ 0
1798 endif
1799
1800 quiet_cmd_sym ?= SYM $@
1801 cmd_sym ?= $(OBJDUMP) -t $< > $@
1802 u-boot.sym: u-boot FORCE
1803 $(call if_changed,sym)
1804
1805 # Environment processing
1806 # ---------------------------------------------------------------------------
1807
1808 # Directory where we expect the .env file, if it exists
1809 ENV_DIR := $(srctree)/board/$(BOARDDIR)
1810
1811 # Basename of .env file, stripping quotes
1812 ENV_SOURCE_FILE := $(CONFIG_ENV_SOURCE_FILE:"%"=%)
1813
1814 # Filename of .env file
1815 ENV_FILE_CFG := $(ENV_DIR)/$(ENV_SOURCE_FILE).env
1816
1817 # Default filename, if CONFIG_ENV_SOURCE_FILE is empty
1818 ENV_FILE_BOARD := $(ENV_DIR)/$(CONFIG_SYS_BOARD:"%"=%).env
1819
1820 # Select between the CONFIG_ENV_SOURCE_FILE and the default one
1821 ENV_FILE := $(if $(ENV_SOURCE_FILE),$(ENV_FILE_CFG),$(wildcard $(ENV_FILE_BOARD)))
1822
1823 # Run the environment text file through the preprocessor, but only if it is
1824 # non-empty, to save time and possible build errors if something is wonky with
1825 # the board.
1826 # If there is no ENV_FILE, produce an empty output file, to prevent a previous
1827 # build's file being used in the case of in-tree builds.
1828 quiet_cmd_gen_envp = ENVP $@
1829 cmd_gen_envp = \
1830 if [ -s "$(ENV_FILE)" ]; then \
1831 $(CPP) -P $(CFLAGS) -x assembler-with-cpp -D__ASSEMBLY__ \
1832 -D__UBOOT_CONFIG__ \
1833 -I . -I include -I $(srctree)/include \
1834 -include linux/kconfig.h -include include/config.h \
1835 -I$(srctree)/arch/$(ARCH)/include \
1836 $< -o $@; \
1837 else \
1838 rm -f $@; \
1839 touch $@ ; \
1840 fi
1841 include/generated/env.in: include/generated/env.txt FORCE
1842 $(call cmd,gen_envp)
1843
1844 # Regenerate the environment if it changes
1845 # We use 'wildcard' since the file is not required to exist (at present), in
1846 # which case we don't want this dependency, but instead should create an empty
1847 # file
1848 # This rule is useful since it shows the source file for the environment
1849 quiet_cmd_envc = ENVC $@
1850 cmd_envc = \
1851 if [ -f "$<" ]; then \
1852 cat $< > $@; \
1853 elif [ -n "$(ENV_SOURCE_FILE)" ]; then \
1854 echo "Missing file $(ENV_FILE_CFG)"; \
1855 else \
1856 touch $@ ; \
1857 fi
1858
1859 include/generated/env.txt: $(wildcard $(ENV_FILE)) FORCE
1860 $(call cmd,envc)
1861
1862 # Write out the resulting environment, converted to a C string
1863 quiet_cmd_gen_envt = ENVT $@
1864 cmd_gen_envt = \
1865 awk -f $(srctree)/scripts/env2string.awk $< >$@
1866 $(env_h): include/generated/env.in
1867 $(call cmd,gen_envt)
1868
1869 # ---------------------------------------------------------------------------
1870
1871 # The actual objects are generated when descending,
1872 # make sure no implicit rule kicks in
1873 $(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1874
1875 # Handle descending into subdirectories listed in $(u-boot-dirs)
1876 # Preset locale variables to speed up the build process. Limit locale
1877 # tweaks to this spot to avoid wrong language settings when running
1878 # make menuconfig etc.
1879 # Error messages still appears in the original language
1880
1881 PHONY += $(u-boot-dirs)
1882 $(u-boot-dirs): prepare scripts
1883 $(Q)$(MAKE) $(build)=$@
1884
1885 tools: prepare
1886 # The "tools" are needed early
1887 $(filter-out tools, $(u-boot-dirs)): tools
1888 # The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1889 # is "yes"), so compile examples after U-Boot is compiled.
1890 examples: $(filter-out examples, $(u-boot-dirs))
1891
1892 define filechk_uboot.release
1893 echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1894 endef
1895
1896 # Store (new) UBOOTRELEASE string in include/config/uboot.release
1897 include/config/uboot.release: include/config/auto.conf FORCE
1898 $(call filechk,uboot.release)
1899
1900
1901 # Things we need to do before we recursively start building the kernel
1902 # or the modules are listed in "prepare".
1903 # A multi level approach is used. prepareN is processed before prepareN-1.
1904 # archprepare is used in arch Makefiles and when processed asm symlink,
1905 # version.h and scripts_basic is processed / created.
1906
1907 # Listed in dependency order
1908 PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1909
1910 # prepare3 is used to check if we are building in a separate output directory,
1911 # and if so do:
1912 # 1) Check that make has not been executed in the kernel src $(srctree)
1913 prepare3: include/config/uboot.release
1914 ifneq ($(KBUILD_SRC),)
1915 @$(kecho) ' Using $(srctree) as source for U-Boot'
1916 $(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1917 echo >&2 " $(srctree) is not clean, please run 'make mrproper'"; \
1918 echo >&2 " in the '$(srctree)' directory.";\
1919 /bin/false; \
1920 fi;
1921 endif
1922
1923 # prepare2 creates a makefile if using a separate output directory
1924 prepare2: prepare3 outputmakefile cfg
1925
1926 prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) $(env_h) \
1927 include/config/auto.conf
1928 ifeq ($(wildcard $(LDSCRIPT)),)
1929 @echo >&2 " Could not find linker script."
1930 @/bin/false
1931 endif
1932
1933 ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1934 prepare1: $(defaultenv_h)
1935
1936 envtools: $(defaultenv_h)
1937 endif
1938
1939 archprepare: prepare1 scripts_basic
1940
1941 prepare0: archprepare FORCE
1942 $(Q)$(MAKE) $(build)=.
1943
1944 # All the preparing..
1945 prepare: prepare0
1946
1947 # Generate some files
1948 # ---------------------------------------------------------------------------
1949
1950 # Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1951 define filechk_version.h
1952 (echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1953 echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
1954 echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1955 echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1956 sed -e "s/^0*//"); \
1957 echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1958 echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1959 endef
1960
1961 # The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1962 # The BSD date on the other hand behaves different and would produce errors
1963 # with the misused '-d' switch. Respect that and search a working date with
1964 # well known pre- and suffixes for the GNU variant of date.
1965 define filechk_timestamp.h
1966 (if test -n "$${SOURCE_DATE_EPOCH}"; then \
1967 SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1968 DATE=""; \
1969 for date in gdate date.gnu date; do \
1970 $${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
1971 done; \
1972 if test -n "$${DATE}"; then \
1973 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
1974 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
1975 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1976 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1977 else \
1978 return 42; \
1979 fi; \
1980 else \
1981 LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
1982 LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
1983 LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1984 LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
1985 fi)
1986 endef
1987
1988 define filechk_defaultenv.h
1989 ( { grep -v '^#' | grep -v '^$$' || true ; echo '' ; } | \
1990 tr '\n' '\0' | \
1991 sed -e 's/\\\x0\s*//g' | \
1992 xxd -i ; )
1993 endef
1994
1995 define filechk_dt.h
1996 (if test -n "$${DEVICE_TREE}"; then \
1997 echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
1998 else \
1999 echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
2000 fi)
2001 endef
2002
2003 $(version_h): include/config/uboot.release FORCE
2004 $(call filechk,version.h)
2005
2006 $(timestamp_h): $(srctree)/Makefile FORCE
2007 $(call filechk,timestamp.h)
2008
2009 $(dt_h): $(srctree)/Makefile FORCE
2010 $(call filechk,dt.h)
2011
2012 $(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
2013 $(call filechk,defaultenv.h)
2014
2015 # ---------------------------------------------------------------------------
2016 # Devicetree files
2017
2018 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/boot/dts/),)
2019 dtstree := arch/$(SRCARCH)/boot/dts
2020 endif
2021
2022 ifneq ($(dtstree),)
2023
2024 %.dtb: prepare3 scripts_dtc
2025 $(Q)$(MAKE) $(build)=$(dtstree) $(dtstree)/$@
2026
2027 PHONY += dtbs dtbs_install
2028 dtbs: prepare3 scripts_dtc
2029 $(Q)$(MAKE) $(build)=$(dtstree)
2030
2031 dtbs_install:
2032 $(Q)$(MAKE) $(dtbinst)=$(dtstree)
2033
2034 ifdef CONFIG_OF_EARLY_FLATTREE
2035 all: dtbs
2036 endif
2037
2038 endif
2039
2040 # Check dtc and pylibfdt, if DTC is provided, else build them
2041 PHONY += scripts_dtc
2042 scripts_dtc: scripts_basic
2043 $(Q)if test "$(DTC)" = "$(DTC_INTREE)"; then \
2044 $(MAKE) $(build)=scripts/dtc; \
2045 else \
2046 if ! $(DTC) -v >/dev/null; then \
2047 echo '*** Failed to check dtc version: $(DTC)'; \
2048 false; \
2049 else \
2050 if test "$(call dtc-version)" -lt $(DTC_MIN_VERSION); then \
2051 echo '*** Your dtc is too old, please upgrade to dtc $(DTC_MIN_VERSION) or newer'; \
2052 false; \
2053 else \
2054 if [ -n "$(CONFIG_PYLIBFDT)" ]; then \
2055 if ! echo "import libfdt" | $(PYTHON3) 2>/dev/null; then \
2056 echo '*** pylibfdt does not seem to be available with $(PYTHON3)'; \
2057 false; \
2058 fi; \
2059 fi; \
2060 fi; \
2061 fi; \
2062 fi
2063
2064 # ---------------------------------------------------------------------------
2065 quiet_cmd_cpp_lds = LDS $@
2066 cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
2067 -D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
2068
2069 u-boot.lds: $(LDSCRIPT) prepare FORCE
2070 $(call if_changed_dep,cpp_lds)
2071
2072 spl/u-boot-spl.bin: spl/u-boot-spl
2073 @:
2074 $(SPL_SIZE_CHECK)
2075
2076 spl/u-boot-spl-dtb.bin: spl/u-boot-spl
2077 @:
2078
2079 spl/u-boot-spl-dtb.hex: spl/u-boot-spl
2080 @:
2081
2082 spl/u-boot-spl: tools prepare $(if $(CONFIG_SPL_OF_CONTROL),dts/dt.dtb)
2083 $(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
2084
2085 spl/sunxi-spl.bin: spl/u-boot-spl
2086 @:
2087
2088 spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
2089 @:
2090
2091 spl/u-boot-spl.sfp: spl/u-boot-spl
2092 @:
2093
2094 spl/boot.bin: spl/u-boot-spl
2095 @:
2096
2097 tpl/u-boot-tpl.bin: tpl/u-boot-tpl
2098 @:
2099 $(TPL_SIZE_CHECK)
2100
2101 tpl/u-boot-tpl: tools prepare $(if $(CONFIG_TPL_OF_CONTROL),dts/dt.dtb)
2102 $(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
2103
2104 vpl/u-boot-vpl.bin: vpl/u-boot-vpl
2105 @:
2106 $(VPL_SIZE_CHECK)
2107
2108 vpl/u-boot-vpl: tools prepare $(if $(CONFIG_TPL_OF_CONTROL),dts/dt.dtb)
2109 $(Q)$(MAKE) obj=vpl -f $(srctree)/scripts/Makefile.spl all
2110
2111 TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
2112
2113 FIND := find
2114 FINDFLAGS := -L
2115
2116 tags ctags:
2117 ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2118 -name '*.[chS]' -print`
2119 ln -s ctags tags
2120
2121 etags:
2122 etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2123 -name '*.[chS]' -print`
2124 cscope:
2125 $(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
2126 cscope.files
2127 @find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
2128 grep -xvf - cscope.files > cscope.files.no-symlinks; \
2129 mv cscope.files.no-symlinks cscope.files
2130 cscope -b -q -k
2131
2132 SYSTEM_MAP = \
2133 $(NM) $1 | \
2134 grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
2135 LC_ALL=C sort
2136 System.map: u-boot
2137 @$(call SYSTEM_MAP,$<) > $@
2138
2139 #########################################################################
2140
2141 # ARM relocations should all be R_ARM_RELATIVE (32-bit) or
2142 # R_AARCH64_RELATIVE (64-bit).
2143 checkarmreloc: u-boot
2144 @RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
2145 grep R_A | sort -u`"; \
2146 if test "$$RELOC" != "R_ARM_RELATIVE" -a \
2147 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
2148 echo "$< contains unexpected relocations: $$RELOC"; \
2149 false; \
2150 fi
2151
2152 tools/version.h: include/version.h
2153 $(Q)mkdir -p $(dir $@)
2154 $(call if_changed,copy)
2155
2156 envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2157 $(Q)$(MAKE) $(build)=tools/env
2158
2159 tools-only: export TOOLS_ONLY=y
2160 tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2161 $(Q)$(MAKE) $(build)=tools
2162
2163 tools-all: export HOST_TOOLS_ALL=y
2164 tools-all: envtools tools ;
2165
2166 cross_tools: export CROSS_BUILD_TOOLS=y
2167 cross_tools: tools ;
2168
2169 .PHONY : CHANGELOG
2170 CHANGELOG:
2171 git log --no-merges U-Boot-1_1_5.. | \
2172 unexpand -a | sed -e 's/\s\s*$$//' > $@
2173
2174 #########################################################################
2175
2176 ###
2177 # Cleaning is done on three levels.
2178 # make clean Delete most generated files
2179 # Leave enough to build external modules
2180 # make mrproper Delete the current configuration, and all generated files
2181 # make distclean Remove editor backup files, patch leftover files and the like
2182
2183 # Directories & files removed with 'make clean'
2184 CLEAN_DIRS += $(MODVERDIR) \
2185 $(foreach d, spl tpl, $(patsubst %,$d/%, \
2186 $(filter-out include, $(shell ls -1 $d 2>/dev/null))))
2187
2188 CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h \
2189 include/generated/env.* drivers/video/u_boot_logo.S \
2190 tools/version.h u-boot* MLO* SPL System.map fit-dtb.blob* \
2191 u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2192 lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2193 idbloader.img flash.bin flash.log defconfig keep-syms-lto.c \
2194 mkimage-out.spl.mkimage mkimage.spl.mkimage imx-boot.map \
2195 itb.fit.fit itb.fit.itb itb.map spl.map mkimage-out.rom.mkimage \
2196 mkimage.rom.mkimage rom.map simple-bin.map simple-bin-spi.map \
2197 idbloader-spi.img
2198
2199 # Directories & files removed with 'make mrproper'
2200 MRPROPER_DIRS += include/config include/generated spl tpl \
2201 .tmp_objdiff doc/output include/asm
2202
2203 # Remove include/asm symlink created by U-Boot before v2014.01
2204 MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2205 ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2206 drivers/video/fonts/*.S include/asm
2207
2208 # clean - Delete most, but leave enough to build external modules
2209 #
2210 clean: rm-dirs := $(CLEAN_DIRS)
2211 clean: rm-files := $(CLEAN_FILES)
2212
2213 clean-dirs := $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2214
2215 clean-dirs := $(addprefix _clean_, $(clean-dirs))
2216
2217 PHONY += $(clean-dirs) clean archclean
2218 $(clean-dirs):
2219 $(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2220
2221 clean: $(clean-dirs)
2222 $(call cmd,rmdirs)
2223 $(call cmd,rmfiles)
2224 @find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2225 \( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2226 -o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2227 -o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2228 -o -name '*.lex.c' -o -name '*.tab.[ch]' \
2229 -o -name '*.asn1.[ch]' \
2230 -o -name '*.symtypes' -o -name 'modules.order' \
2231 -o -name modules.builtin -o -name '.tmp_*.o.*' \
2232 -o -name 'dsdt_generated.aml' -o -name 'dsdt_generated.asl.tmp' \
2233 -o -name 'dsdt_generated.c' \
2234 -o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2235 -type f -print | xargs rm -f
2236
2237 # mrproper - Delete all generated files, including .config
2238 #
2239 mrproper: rm-dirs := $(wildcard $(MRPROPER_DIRS))
2240 mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2241 mrproper-dirs := $(addprefix _mrproper_,scripts)
2242
2243 PHONY += $(mrproper-dirs) mrproper archmrproper
2244 $(mrproper-dirs):
2245 $(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2246
2247 mrproper: clean $(mrproper-dirs)
2248 $(call cmd,rmdirs)
2249 $(call cmd,rmfiles)
2250 @rm -f arch/*/include/asm/arch
2251
2252 # distclean
2253 #
2254 PHONY += distclean
2255
2256 distclean: mrproper
2257 @find $(srctree) $(RCS_FIND_IGNORE) \
2258 \( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2259 -o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2260 -o -name '.*.rej' -o -name '*%' -o -name 'core' \
2261 -o -name '*.pyc' \) \
2262 -type f -print | xargs rm -f
2263 @rm -f boards.cfg CHANGELOG
2264
2265 # See doc/develop/python_cq.rst
2266 PHONY += pylint pylint_err
2267 PYLINT_BASE := scripts/pylint.base
2268 PYLINT_CUR := pylint.cur
2269 PYLINT_DIFF := pylint.diff
2270 pylint:
2271 $(Q)echo "Running pylint on all files (summary in $(PYLINT_CUR); output in pylint.out/)"
2272 $(Q)mkdir -p pylint.out
2273 $(Q)rm -f pylint.out/out*
2274 $(Q)find tools test -name "*.py" \
2275 | xargs -n1 -P$(shell nproc 2>/dev/null || echo 1) \
2276 sh -c 'pylint --reports=y --exit-zero -f parseable --ignore-imports=yes $$@ > pylint.out/$$(echo $$@ | tr / _ | sed s/.py//)' _
2277 $(Q)rm -f $(PYLINT_CUR)
2278 $(Q)( cd pylint.out; for f in *; do \
2279 sed -ne "s/Your code has been rated at \([-0-9.]*\).*/$$f \1/p" $$f; \
2280 done ) | sort > $(PYLINT_CUR)
2281 $(Q)base=$$(mktemp) cur=$$(mktemp); cut -d' ' -f1 $(PYLINT_BASE) >$$base; \
2282 cut -d' ' -f1 $(PYLINT_CUR) >$$cur; \
2283 comm -3 $$base $$cur > $(PYLINT_DIFF); \
2284 if [ -s $(PYLINT_DIFF) ]; then \
2285 echo "Files have been added/removed. Try:\n\tcp $(PYLINT_CUR) $(PYLINT_BASE)"; \
2286 echo; \
2287 echo "Added files:"; \
2288 comm -13 $$base $$cur; \
2289 echo; \
2290 echo "Removed files:"; \
2291 comm -23 $$base $$cur; \
2292 false; \
2293 else \
2294 rm $$base $$cur $(PYLINT_DIFF); \
2295 fi
2296 $(Q)bad=false; while read base_file base_val <&3 && read cur_file cur_val <&4; do \
2297 if awk "BEGIN {exit !($$cur_val < $$base_val)}"; then \
2298 echo "$$base_file: Score was $$base_val, now $$cur_val"; \
2299 bad=true; fi; \
2300 done 3<$(PYLINT_BASE) 4<$(PYLINT_CUR); \
2301 if $$bad; then \
2302 echo "Some files have regressed, please fix"; \
2303 false; \
2304 else \
2305 echo "No pylint regressions"; \
2306 fi
2307
2308 # Check for errors only
2309 pylint_err:
2310 $(Q)pylint -E -j 0 --ignore-imports=yes \
2311 $(shell find tools test -name "*.py")
2312
2313 backup:
2314 F=`basename $(srctree)` ; cd .. ; \
2315 gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
2316
2317 help:
2318 @echo 'Cleaning targets:'
2319 @echo ' clean - Remove most generated files but keep the config'
2320 @echo ' mrproper - Remove all generated files + config + various backup files'
2321 @echo ' distclean - mrproper + remove editor backup and patch files'
2322 @echo ''
2323 @echo 'Configuration targets:'
2324 @$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2325 @echo ''
2326 @echo 'Test targets:'
2327 @echo ''
2328 @echo ' check - Run all automated tests that use sandbox'
2329 @echo ' pcheck - Run quick automated tests in parallel'
2330 @echo ' qcheck - Run quick automated tests that use sandbox'
2331 @echo ' tcheck - Run quick automated tests on tools'
2332 @echo ' pylint - Run pylint on all Python files'
2333 @echo ''
2334 @echo 'Other generic targets:'
2335 @echo ' all - Build all necessary images depending on configuration'
2336 @echo ' tests - Build U-Boot for sandbox and run tests'
2337 @echo '* u-boot - Build the bare u-boot'
2338 @echo ' dir/ - Build all files in dir and below'
2339 @echo ' dir/file.[oisS] - Build specified target only'
2340 @echo ' dir/file.lst - Build specified mixed source/assembly target only'
2341 @echo ' (requires a recent binutils and recent build (System.map))'
2342 @echo ' tags/ctags - Generate ctags file for editors'
2343 @echo ' etags - Generate etags file for editors'
2344 @echo ' cscope - Generate cscope index'
2345 @echo ' ubootrelease - Output the release version string (use with make -s)'
2346 @echo ' ubootversion - Output the version stored in Makefile (use with make -s)'
2347 @echo " cfg - Don't build, just create the .cfg files"
2348 @echo " envtools - Build only the target-side environment tools"
2349 @echo ''
2350 @echo 'Static analysers'
2351 @echo ' checkstack - Generate a list of stack hogs'
2352 @echo ' coccicheck - Execute static code analysis with Coccinelle'
2353 @echo ''
2354 @echo 'Documentation targets:'
2355 @$(MAKE) -f $(srctree)/doc/Makefile dochelp
2356 @echo ''
2357 @echo ' make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2358 @echo ' make V=2 [targets] 2 => give reason for rebuild of target'
2359 @echo ' make O=dir [targets] Locate all output files in "dir", including .config'
2360 @echo ' make C=1 [targets] Check all c source with $$CHECK (sparse by default)'
2361 @echo ' make C=2 [targets] Force check of all c source with $$CHECK'
2362 @echo ' make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2363 @echo ' make W=n [targets] Enable extra gcc checks, n=1,2,3 where'
2364 @echo ' 1: warnings which may be relevant and do not occur too often'
2365 @echo ' 2: warnings which occur quite often but may still be relevant'
2366 @echo ' 3: more obscure warnings, can most likely be ignored'
2367 @echo ' Multiple levels can be combined with W=12 or W=123'
2368 @echo ''
2369 @echo 'Execute "make" or "make all" to build all targets marked with [*] '
2370 @echo 'For further info see the ./README file'
2371
2372 tests check:
2373 $(srctree)/test/run
2374
2375 pcheck:
2376 $(srctree)/test/run parallel
2377
2378 qcheck:
2379 $(srctree)/test/run quick
2380
2381 tcheck:
2382 $(srctree)/test/run tools
2383
2384 # Documentation targets
2385 # ---------------------------------------------------------------------------
2386 DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2387 linkcheckdocs dochelp refcheckdocs
2388 PHONY += $(DOC_TARGETS)
2389 $(DOC_TARGETS): scripts_basic FORCE
2390 $(Q)$(MAKE) $(build)=doc $@
2391
2392 PHONY += checkstack ubootrelease ubootversion
2393
2394 checkstack:
2395 $(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2396 $(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2397
2398 ubootrelease:
2399 @echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2400
2401 ubootversion:
2402 @echo $(UBOOTVERSION)
2403
2404 # Single targets
2405 # ---------------------------------------------------------------------------
2406 # Single targets are compatible with:
2407 # - build with mixed source and output
2408 # - build with separate output dir 'make O=...'
2409 # - external modules
2410 #
2411 # target-dir => where to store outputfile
2412 # build-dir => directory in kernel source tree to use
2413
2414 ifeq ($(KBUILD_EXTMOD),)
2415 build-dir = $(patsubst %/,%,$(dir $@))
2416 target-dir = $(dir $@)
2417 else
2418 zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2419 build-dir = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2420 target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2421 endif
2422
2423 %.s: %.c prepare scripts FORCE
2424 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2425 %.i: %.c prepare scripts FORCE
2426 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2427 %.o: %.c prepare scripts FORCE
2428 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2429 %.lst: %.c prepare scripts FORCE
2430 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2431 %.s: %.S prepare scripts FORCE
2432 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2433 %.o: %.S prepare scripts FORCE
2434 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2435 %.symtypes: %.c prepare scripts FORCE
2436 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2437
2438 # Modules
2439 /: prepare scripts FORCE
2440 $(cmd_crmodverdir)
2441 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2442 $(build)=$(build-dir)
2443 %/: prepare scripts FORCE
2444 $(cmd_crmodverdir)
2445 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2446 $(build)=$(build-dir)
2447 %.ko: prepare scripts FORCE
2448 $(cmd_crmodverdir)
2449 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2450 $(build)=$(build-dir) $(@:.ko=.o)
2451 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2452
2453 quiet_cmd_genenv = GENENV $@
2454 cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2455 sed --in-place -e 's/\x00/\x0A/g' $@; sed --in-place -e '/^\s*$$/d' $@; \
2456 sort --field-separator== -k1,1 --stable $@ -o $@
2457
2458 u-boot-initial-env: u-boot.bin
2459 $(call if_changed,genenv)
2460
2461 # Consistency checks
2462 # ---------------------------------------------------------------------------
2463
2464 PHONY += coccicheck
2465
2466 coccicheck:
2467 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2468
2469 # FIXME Should go into a make.lib or something
2470 # ===========================================================================
2471
2472 quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN $(wildcard $(rm-dirs)))
2473 cmd_rmdirs = rm -rf $(rm-dirs)
2474
2475 quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN $(wildcard $(rm-files)))
2476 cmd_rmfiles = rm -f $(rm-files)
2477
2478 # read all saved command lines
2479
2480 cmd_files := $(wildcard .*.cmd)
2481
2482 ifneq ($(cmd_files),)
2483 $(cmd_files): ; # Do not try to update included dependency files
2484 include $(cmd_files)
2485 endif
2486
2487 endif #ifeq ($(config-targets),1)
2488 endif #ifeq ($(mixed-targets),1)
2489 endif # skip-makefile
2490
2491 PHONY += FORCE
2492 FORCE:
2493
2494 # Declare the contents of the PHONY variable as phony. We keep that
2495 # information in a variable so we can use it in if_changed and friends.
2496 .PHONY: $(PHONY)